Option explicit
Option base 1


'Mode 3,12
'Mode 3,8
CLS

Dim xSize=16
Dim ySize=16

Dim header$="16,1,16"
Dim fileName$="output.spr"

Dim xOffset=5
Dim yOffset=1

Dim xImage=200
Dim yImage=20

Dim xMag=200
Dim yMag=50
Dim mag=4

Dim sBlank$="................"
Dim fBlank$="                "

'screen representation
Dim s$(ySize)

'file representation
Dim f$(ySize)

Dim y,x
For y=1 to ySize
  s$(y)=sBlank$
  f$(y)=fBlank$
Next

Sub LocateEntry x,y
  LocateCell x+xOffset,y+yOffset
End sub

For y=1 to ySize
  For x=1 to xSize
    LocateEntry x,y
    Print mid$(s$(y),x,1);
'    Print ".";
  Next x
  'Print s$(y)
Next
Print
Print
Print "Controls: ZXOK to move, space to clear, 0-7 to set colour"
Print "S to save and display. Warning, will overwrite previous save"
Print "File name: ";fileName$
Print "Q to quit"

Sub SaveSprite
  'Print "Please wait until finished..."
  Open fileName$ for output as #1
  Print #1, header$
  For y=1 to ySize
    Print #1, f$(y)
  Next
  Close #1
  'Print "Done"
  Sprite load fileName$,1
  Sprite show 1, xImage, yImage,1
  Image resize_fast xImage, yImage, xSize, ySize, xMag, yMag, mag * xSize, mag * ySize

  Sprite close all
  Pause 500
End sub

x=1
y=1


Dim c$
Do
  LocateEntry x,y
  Print "C"
  Pause 50
  c$=inkey$
  LocateEntry x,y
  Print mid$(s$(y),x,1);    
  Select case c$
    Case "z","Z"
      x=x-1
    Case "x","X"
      x=x+1
    Case "o","O"
      y=y-1
    Case "k","K"
      y=y+1
    Case "q","Q"
quit: End
    Case " "
      Mid$(s$(y),x,1)="."
      Mid$(f$(y),x,1)=" "
    Case "0" to "7"
      Mid$(s$(y),x,1)=c$
      Mid$(f$(y),x,1)=c$
    Case "S","s"
      SaveSprite
  End select
  x=min(x,xSize)
  x=max(x,1)
  y=min(y,ySize)
  y=max(y,1)
Loop



input y

Sub LocateCell x,y
  Print @(x*MM.Info(FontWidth),y*MM.Info(FontHeight));
  'I tried without a semicolon and it didn't work right.
End Sub


